<?php
######################################################################
# ZW3B.Site v5.8.2 : Web Sites Management
# --------------------------------------------------------------------
#
# Copyright (c) 2015 by LAB3W : O.Romain Jaillet-Ramey - (orj@lab3w.fr)
#
# Date Create : 2014/10/20
# Date Modify : 2015/08/20
#
# Web Site : http://www.zw3b.fr
#
# This module is to manage ---------------------------- :: Descripton
#
# This program is free software. You can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License.
######################################################################

class zw3bStructures extends zw3bTree {
//class zw3bStructures extends zw3b {

	public $name;
	public $pagelayout;
//	public $config;
//	public $info;
	public $skin;

	//public $structure;

	public function __construct($config = null, $info = null, $skin = null)
	{
		$this->config = (isset($config) && !empty($config)) ? $config : $this->config;
		$this->info = (isset($info) && !empty($info)) ? $info : $this->info;

		if(isset($this->info['infos']['skin']) && $this->info['infos']['skin'] != '') $this->theme = $this->info['infos']['skin'];
		elseif(isset($this->theme) && $this->theme != '') $this->theme = $this->theme;
		else $this->theme = $this->config['skin']['uri'];

		//echo $this->config['theme'];

	}


	public function get_structures($from = null) {
		
			$zwStrucuturesDirectory = ($from == null) ? $this->config['host']['documenroot'].'var/zones/' : $from;
		    
		    if(!is_dir($zwStrucuturesDirectory))
		        return false;
		    
		    $files = array();
		    $i = 0;
		    if( $dh = opendir($zwStrucuturesDirectory))
		    {
		        while( false !== ($file = readdir($dh)))
		        {			        	
		            // Skip '.' and '..'
		            if( $file == '.' || $file == '..')
		                continue;
		            
		            $i++;
		            $path = $from . '' . $file;
		            /*if( is_dir($path) )
		                $files += self::get_skins($path);
		            else*/
		                $files[$i]['name'] = str_replace(array("_", "-"), array("&nbsp;&nbsp;:&nbsp;&nbsp;", "&nbsp;&nbsp;"), strstr($file, ".zones.php", true));
		                $files[$i]['file'] = $file;
		                $files[$i]['path'] = $path;
		        }
		        closedir($dh);
		    }
		    
		    sort($files);
		    
		    return $files;
	}

/*
	public function getSkin()
	{
		//echo '<pre>'.print_r($this->info['infos'],1).'</pre>';
		$this->skin = (isset($this->info['infos']['skin']) && !empty($this->info['infos']['skin'])) ? $this->info['infos']['skin'] : $this->config['skin']['name'];

		return $this->skin;
	}
*/
	public function setPagelayout()
	{
		//$this->skin = $this->getSkin();

		$this->pagelayout = (isset($this->info['infos']['pagelayout']) && !empty($this->info['infos']['pagelayout'])) ? $this->info['infos']['pagelayout'] : $this->config['structure']['pagelayout'];
		$this->pagelayout = (isset($this->info['infos']['override']) && !empty($this->info['infos']['override'])) ? $this->info['infos']['override'] : $this->info['infos']['pagelayout'];

		//return "/skins/".$this->getSkin()."/layouts/".$this->pagelayout;
		return "/skins/".$this->info['infos']['skin']."/layouts/".$this->pagelayout;
	}



	public function zw3bStructuresTreeInfosReverse()
	{

		//echo '<pre>'.print_r($this->info,1).'</pre>';

		//$tree = $this->info['page']['zw3bsite']."/".$this->info['page']['dir']
		$curentdir = null;
		$returnMetaTitle = null;
		$returnInfoNameRecursive = null;
		$returnTitle = null;
		$c = count($this->info['dir']);
		foreach($this->info['dir'] as $key => $dir) {

				$curentdir = $curentdir."/".$dir;
				if(file_exists($this->config['host']['documentroot']."/var/tree/".$curentdir)):
					include "./var/tree".$curentdir."/info.gen.php";
					if(isset($info) && !empty($info))
						$tmpInfo['name'] = $info['name'];

					$returnMetaTitle = ($info['id'] == 1 && $this->info['file'][0] == "index") ? trim($returnMetaTitle).'  ' : ''.$tmpInfo['name']." * ".trim($returnMetaTitle);
					//$returnMetaTitle = ''.$tmpInfo['name']." * ".trim($returnMetaTitle);

					$returnTitle = trim($returnTitle).' <a href="//'.substr($curentdir, 1, strlen($curentdir)).'/" class="filarianne">'.$tmpInfo['name'].'</a>';
					if( $c-1 > $key):
						//$returnMetaTitle.=  ' * ';
						$returnTitle.=  ' <span style="font-size:50%;">*</span> ';
					endif;
				endif;
		}

		$this->info['page']['filarianne'] = $returnTitle;
/*		//$this->info['page']['metatitle'] = (isset($tmpInfo['name']) && !empty($tmpInfo['name']) ? $tmpInfo['name'] : $this->config['host']['title']);
//		$this->info['page']['metatitle'] = str_replace(" ", " * ",$returnMetaTitle)." ".str_replace(array(""), array(""), $this->config['host']['title']);
		$this->info['page']['metatitle'] = str_replace("", "", $returnMetaTitle);
		$this->info['page']['metatitle'].= ($this->info['infos']['name'] != $this->config['host']['title']) ? " ".$this->config['host']['title'] : "";
		// ?? pour enlever le * ds les contents de la home
		$this->info['page']['metatitle'] = ($this->info['infos']['id'] == 1) ? substr($this->info['page']['metatitle'], 0, -2) : $this->info['page']['metatitle'];
*/
		$vhost_infos = $this->tree->getInfos();
		$vhost_infos = $this->tree->getInfos("my.zw3b.fr/");
		//$vhost_infos['name'] = "ZW3B";		
//echo '<pre>'.print_r($this->info,1).'</pre>';
		// HOMEPAGE
		if($this->info['infos']['id'] == 1 && $this->info['file'][0] == "index") {
			
			$this->info['page']['metatitle'] = substr($returnMetaTitle, 0, -1);
		} 
		// TREE
		elseif($this->info['infos']['id'] != 1 && $this->info['file'][0] == "index") {
		
			$this->info['page']['metatitle'] = substr($returnMetaTitle, 0, -2);

			// HOST
			if(
				substr($this->info['infos']['uri'],0, 2) == "//"
				&& strToLower($this->config['host']['uri']) == strToLower($this->info['infos']['uri'])
			) {
				
				$this->info['page']['metatitle'].= " * ".$vhost_infos['name']; // HP
			} 
			else {
				$this->info['page']['metatitle'].= " * ".$vhost_infos['name']; // tree
			}
		} 
		// CONTENT
		else {
			
			$this->info['page']['metatitle'] = $returnMetaTitle;

			// PARENT HOST
			if(
				substr($this->info['infos']['uri'], 0, 2) == "//"
				&& strToLower($this->config['host']['uri']) == strToLower($this->info['infos']['uri'])
				&& strToLower($this->config['host']['uri']) == strToLower($vhost_infos['uri'])
			) {
				$this->info['page']['metatitle'] = substr($this->info['page']['metatitle'], 0, -2);
				
			} 
			// PARENT VHOST
			else if(
				substr($this->info['infos']['uri'], 0, 2) == "//"
				&& strToLower($this->config['host']['uri']) == strToLower($this->info['infos']['uri'])
				&& strToLower($this->config['host']['uri']) != strToLower($vhost_infos['uri'])
			) {
				$this->info['page']['metatitle'].= " ".$vhost_infos['name'];
				//$this->info['page']['metatitle'] = substr($this->info['page']['metatitle'], 0, -2);
			}
			// PARENT TREE
			else {
				 
				if(strToLower($this->config['host']['uri']) != strToLower($vhost_infos['uri'])) {
					$this->info['page']['metatitle'].= " ".$vhost_infos['name'];
					//$this->info['page']['metatitle'].= " ";
					//echo "URI:".$vhost_infos['uri'];
				}
				else
					$this->info['page']['metatitle'] = substr($this->info['page']['metatitle'], 0, -2);
				
				//$this->info['page']['metatitle'] = substr($this->info['page']['metatitle'], 0, -2);
			}			

		}
		
		$this->info['dirname'] = $returnInfoNameRecursive;

		return $this->info;
	}

/*
	public function getFilArianeDefault($tree = null)
	{

		$urlparse = $this->urlparse;


		if($tree == null) {
			$tree = $this->getTree($urlparse);
			$tree = './var/tree'.$tree;
		} else
			$tree = './var/tree/'.$tree.'';

		$tmpinfo['url'] = $this->urlparse;

		$folder = null;

		$returnInfoNameRecursive = '';
		$returnFilArianne = '';

		// Parcours de l'URL depuis la racine
		foreach( $tmpinfo['url']['folder'] as $key => $currentfolder):

					$folder = $folder.'/'.$currentfolder;
					//$returninfotmp['url']['redirect'] = $oldfolder.'/';
					if(file_exists('./var/tree/'.$folder))
					{
						//echo $folder.'<br/>';

						$tmpInfo = self::getInfo($folder);

						$returnInfoNameRecursive = $returnInfoNameRecursive.' '.$tmpInfo['name'];

						//$returnFilArianne = $returnFilArianne.' <a href="'.$this->info['url']['root'].'/'.$folder.'" class="filarianne">'.$tmpInfo['name'].'</a>';
						$returnFilArianne = $returnFilArianne.' <a href="'.self::vhost().''.substr($folder, 1, strlen($folder)).'/" class="filarianne">'.$tmpInfo['name'].'</a>';

						if( count($tmpinfo['url']['folder'])-1 > $key):
							$returnInfoNameRecursive.=  ' > ';
							$returnFilArianne.=  ' - ';
						endif;

					}


		endforeach;

		//$returninfo = self::liste_tree($folder);
		//echo '<pre>'.print_r($returninfo,1).'</pre>';
		//exit;
		$pageInfos['filarianne'] = $returnFilArianne;
		$pageInfos['dirname'] = $returnInfoNameRecursive;


		return $pageInfos;
	}
*/

	public function getPagelayout($info, $components = array())
	{

		$this->info = $info;
		$view = $this->info["pagelayout"];
		$render_pagelayout = '> chargement du template '.$view.'<br/>';
		
		//-----------------------------------------
		// temp : Author des rubriques
		if($this->info['page']['zw3bsite'] != "radio.zw3b.fr" && $this->info['page']['zw3bsite'] != "radi0.zw3b.fr") {
			$this->fields['metaowner'] = $this->config['host']['owner'];
			$this->fields['metaauthor'] = isset($this->config['host']['author']) && !empty($this->config['host']['author']) ? $this->config['host']['author'] : 'O.Romain Jaillet-Ramey alias LAB3W.ORJ';
			$this->fields['metacopy'] = $this->config['host']['copyright'];
		} else {
			$this->fields['metaowner'] = $this->config['host']['owner'];
			$this->fields['metaauthor'] = isset($this->config['host']['author']) && !empty($this->config['host']['author']) ? $this->config['host']['author'] : 'O.Romain Jaillet-Ramey alias LAB3W.ORJ';;
			$this->fields['metacopy'] = $this->config['host']['copyright'];
		}
		if($this->info['page']['zw3bsite'] == "radio.zw3b.fr" || $this->info['page']['zw3bsite'] == "radi0.zw3b.fr")
			$this->fields['metareplyto'] = $this->zwTools()->replace_mail($this->config['host']['reply']);
		else
			$this->fields['metareplyto'] = $this->zwTools()->replace_mail($this->config['host']['reply']);
		
		//-----------------------------------------
		//-----------------------------------------
		$this->fields['metagenerator'] = strToUpper($this->config['apps']['conf']['title'].' '.$this->config['apps']['conf']['vs']).' : '.$this->config['apps']['conf']['desc'];
		$stats = stat($this->config['apps']['conf']['rootdir']);
		$this->fields['metageneratordatecreate'] = "2014-10-19"; //date("Y-m-d", $stats['ctime']);
		$zwstats = stat($this->config['host']['documentroot']."/sys/kernel/zw3b.class.php");
		$zmstats = stat($this->config['host']['documentroot']."/sys/modules/");
		$this->fields['metageneratordateupdate'] = date("Y-m-d", ($zwstats['mtime'] > $zmstats['ctime']) ? $zwstats['mtime'] : $zmstats['ctime']);
		//-----------------------------------------

		//-----------------------------------------
		$this->fields['gaid'] = '<!-- google-analytics-id -->';
		$this->fields['gsv'] = '<!-- google-site-verification -->';
		if($this->info['page']['zw3bsite'] == "www.zw3b.fr" || $this->info['page']['zw3bsite'] == "my.zw3b.fr") {
			$this->fields['gaid'] = $this->config['host']['ga'];
			$this->fields['gsv'] = '';
		}
		if($this->info['page']['zw3bsite'] == "howto.zw3b.fr" || $this->info['page']['zw3bsite'] == "h0wt0.zw3b.fr") {
			$this->fields['gaid'] = 'UA-36011703-7';
			$this->fields['gsv'] = '<meta name="google-site-verification" content="yKL-9x1qMxt-ItMPJVRhH4ZFF0637n-xC4IxUH0zP9I" />';
		}
		if($this->info['page']['zw3bsite'] == "radio.zw3b.fr" || $this->info['page']['zw3bsite'] == "radi0.zw3b.fr") {
			$this->fields['gaid'] = 'UA-36011703-4';
			$this->fields['gsv'] = '<meta name="google-site-verification" content="yKL-9x1qMxt-ItMPJVRhH4ZFF0637n-xC4IxUH0zP9I" />';
		}
		if($this->info['page']['zw3bsite'] == "apps.zw3b.fr" || $this->info['page']['zw3bsite'] == "appz.zw3b.fr") {
			$this->fields['gaid'] = 'UA-36011703-8';
			$this->fields['gsv'] = '<meta name="google-site-verification" content="yKL-9x1qMxt-ItMPJVRhH4ZFF0637n-xC4IxUH0zP9I" />';
		}
		$this->fields['zw3bsite'] = $this->info['page']['zw3bsite'];
		
		//-----------------------------------------
		//$this->info['page']['metatitle'] = (isset($tmpInfo['name']) && !empty($tmpInfo['name']) ? $tmpInfo['name'] : $this->config['host']['title']);

		//echo '<pre>'.print_r($this->info,1).'</pre>';
		//-----------------------------------------
		// temp : a recuperer dans les infos
		$this->fields['metarobots'] = $this->config['host']['robots'];
		$this->fields['metarating'] = $this->config['host']['rating'];
		$this->fields['metadistribution'] = $this->config['host']['distribution'];
		$this->fields['metaaudience'] = $this->config['host']['audience'];
		$this->fields['metarevisitafter'] = $this->config['host']['revisit'];
		//-----------------------------------------
		$this->fields['metatitle'] = null;
		if($this->config['host']['title'] != $this->info['infos']['name'])
			$this->fields['metatitle'] = $this->info['infos']['name'];
		else
			$this->fields['metatitle'] = $this->config['host']['title'];

		//-----------------------------------------
		$this->fields['metatitlehomepage'] = null;
		if($this->info['infos']['id'] == 1 && $this->info['file'][0] == "index")
		{
			//$this->fields['metatitle'] = trim(str_replace(array("www", "&gt;"), array(""), $this->info['page']['metatitle']));
			//$this->fields['metatitle'] = trim($this->info['page']['metatitle']);
			$this->fields['metatitlehomepage'] = ' :-: '.$this->info['infos']['description'];

			if(isset($this->info['page']['uri']) && !empty($this->info['page']['uri']) )
				$this->fields['metatitle'] = $this->info['infos']['name'] ." &gt; ".$this->info['page']['metatitle'];

		}
		else if	($this->info['infos']['id'] == 1 && $this->info['file'][0] != "index") {

			if(isset($this->info['page']['uri']) && !empty($this->info['page']['uri']) )
				$this->fields['metatitle'] = $this->info['infos']['name'] ." &gt; ".$this->info['page']['metatitle'];

		}
		else if($this->config['host']['title'] != $this->info['infos']['name'] && !isset($this->info['folder']['parent'][0])) {
			$this->fields['metatitle'] = $this->info['page']['metatitle'];
		}
		else {
			$this->fields['metatitle'] = $this->info['page']['metatitle'];


	/*hack*/if(isset($this->info['page']['dirname'])) $dirname = $this->info['page']['dirname']; else $dirname = $this->fields['metatitle'];
			$tmpMetaTitle = explode(' > ', $dirname);
			$tmpMetaTitle = array_reverse($tmpMetaTitle);
			$tmpMetaTitle = implode(' < ', $tmpMetaTitle);

			//$tmpMetaTitle = array_reverse($tmpMetaTitle);
			//$tmpMetaTitle = impode(' < ', $tmpMetaTitle);
			//if(!strstr($tmpMetaTitle, '', $this->info['name']))
				$this->fields['metatitle'] = $this->info['name'].' :-: '.str_replace($this->info['infos']['name'].' < ', '', $tmpMetaTitle);

				$this->fields['classrub'] = trim(str_replace('/', ' ', $this->info['page']['dir']));

			//else
				//$this->fields['metatitle'] = $tmpMetaTitle;
		}
		//$this->fields['metatitle'] = $this->zwTools()->string_decode($this->fields['metatitle']);
		//-----------------------------------------
#		$this->fields['metadescription'] = zw3bTools::string_encode(trim($this->info['infos']['description']));
//		$this->fields['metadescription'] = trim(htmlentities($this->info['infos']['description'], ENT_COMPAT));
		$this->fields['metadescription'] = $this->zwTools()->string_encode($this->info['infos']['description']);
		$this->fields['metakeywords'] = trim($this->info['infos']['keywords']);

		//if(isset($this->info['theme']) && $this->info['theme'] != '') $this->theme = $this->info['theme'];
		//else $this->theme = $this->config['theme'];
		//-----------------------------------------
		$this->fields['theme'] = $this->theme;
		//-----------------------------------------
		//echo '<pre>'.print_r($this->fields['metadescription'],1).'</pre>';
		//-----------------------------------------
		$this->fields['classpage'] = ''; // on peut aussi mod avec dif sites >
		if(isset($this->info['folder'][0]) && !empty($this->info['folder'][0]) ) {
			$this->fields['classpage'] = str_replace(".zw3b.fr", "", $this->info['page']['zw3bsite'])." ".$this->info['folder'][0];
		} else $this->fields['classpage'] = str_replace(".zw3b.fr", "", $this->info['page']['zw3bsite']).' home';
		//-----------------------------------------
		//-----------------------------------------
		$this->fields['typepage'] = '';
		if(isset($this->info['file'][0]) && $this->info['file'][0] == 'index' ) {
			$this->fields['typepage'] = 'folder';
			$this->fields['metarefresh'] = ( !isset($this->info['dir'][1]) || ( isset($this->info['dir'][1]) && (empty($this->info['dir'][1]) || $this->info['url'][1] != "admin")) ) ? '<meta http-equiv="Refresh" content="3600" />' : '';
		} else {
			$this->fields['typepage'] = 'contents';
			$this->fields['metarefresh'] = ( !isset($this->info['dir'][1]) || ( isset($this->info['dir'][1]) && (empty($this->info['dir'][1]) || $this->info['url'][1] != "admin")) ) ? '<meta http-equiv="Refresh" content="1500" />' : '';
		}
		//-----------------------------------------

		//-----------------------------------------
		//$this->fields['random'] = "".rand();
		$this->fields['random'] = "".rand();
		//$this->fields['zw3bsite'] = $this->info['page']['zw3bsite'];
		//-----------------------------------------
		//echo '<pre>zw3bStructures>getPagelayout>'.print_r($this->info,1).'</pre>';

		

		//-----------------------------------------
		// Les zones principales
		$this->fields['zw-master'] = zw3bViews::getViewsComponents('zw-master', $this->info);

		$this->fields['zw-header'] = zw3bViews::getViewsComponents('zw-header', $this->info);
		$this->fields['zw-menu'] = zw3bViews::getViewsComponents('zw-menu', $this->info);

		if(isset($this->info['file']['0']) && !empty($this->info['file']['0']) && $this->info['file']['0'] == "index")
			$this->fields['zw-main'] = zw3bViews::getViewsComponents('zw-main', $this->info);
		else {
			/*
				On chargait de MAIN-TPL des contents / TMP
			*/
			//$this->info['zones']['zw-main']['zw-main'][1] = $this->info['zones']['zw-main']['zw-main-une'][1];
			$this->info['zones']['zw-main']['zw-main-une'][1] = null;
			unset($this->info['zones']['zw-main']['zw-main-une'][1]);

			$this->info['zones']['zw-main']['zw-main-bloc'] = null;
			unset($this->info['zones']['zw-main']['zw-main-bloc']);
			
			if($this->info['page']['zw3bsite'] == "radio.zw3b.fr" || $this->info['page']['zw3bsite'] == "radi0.zw3b.fr")  
			{

			}
			else {
				$this->info['zones']['zw-main']['zw-main-colonne'] = null;
				unset($this->info['zones']['zw-main']['zw-main-colonne']);				
			}
			$this->info['zones']['zw-main']['zw-main'][1] = null;
			unset($this->info['zones']['zw-main']['zw-main'][1]);


			//$this->info['zones']['zw-main']['zw-main'][0]['tpl'] = "./sys/modules/contents/default/tpl/zw-contents.main.php";
			//$this->info['zones']['zw-main']['zw-main'][0]['module'] = "zw3bModContents";
			#$this->info['zones']['zw-main']['zw-main'][0]['function'] = "detail_main";
			//$this->info['zones']['zw-main']['zw-main'][0]['div'] = "zw-main0";
			//$this->info['zones']['zw-main']['zw-main'][0]['arguments'] = array();


			//zw3bViews::getView($div['div'], $div['tpl'], $div['module'], $div['function'], $div['arguments'])
			//$this->fields['zw-main'] = $this->zwViews()->getViewsComponents('zw-main', $this->info);
			$this->fields['zw-main'] = zw3bViews::getViewsComponents('zw-main', $this->info);
		}
		$this->fields['zw-footer'] = zw3bViews::getViewsComponents('zw-footer', $this->info);
		// Les zones principales
		//-----------------------------------------


		//echo '<pre>'.print_r($this->fields,1).'</pre>';

		// Template
		$view = '.'.$view;
		if(file_exists($view)):

			//echo 'on charge '.$tpllayout.'<br/>';

			$modele = @fopen ($view, 'r');
			$render_pagelayout = @fread ($modele, @filesize ($view));
			@fclose ($modele);

			// Parcours du tableau $fields
			if(is_array($this->fields)):
			//echo 'on charge les champs '.print_r($this->fields, 1).'<br/>';
			foreach ($this->fields as $key => $value){
				// Remplacement des valeurs dans le modle
				$result = @ereg_replace ("{".$key."}", $value, $render_pagelayout);
				// Initialisation du contenu du template
				$render_pagelayout = $result;
			}
			endif;
			//$render_pagelayout.= '> Template '.$view.' ok<br/>';
		else:
			$render_pagelayout = '<p style="color:white; background-color:red;"><span style="color:white;">&nbsp;Error:</span> Layout "<span style="color:black;">'.$view.'</span>" n\'existe pas !</p>';
		endif;



			return $render_pagelayout;

		//include $this->info['pagelayout'];
	}



	public function getViewsComponents($name = null, $config = null, $info = null) {
/*
	$this->info['zones']['zw-master'] = isset($this->info['zones']['zw-master']) && !empty($this->info['zones']['zw-master']) ? $this->info['zones']['zw-footer'] : array();
	$this->info['zones']['zw-header'] = isset($this->info['zones']['zw-header']) && !empty($this->info['zones']['zw-header']) ? $this->info['zones']['zw-footer'] : array();
	$this->info['zones']['zw-menu'] = isset($this->info['zones']['zw-menu']) && !empty($this->info['zones']['zw-menu']) ? $this->info['zones']['zw-menu'] : array();
	$this->info['zones']['zw-footer'] = isset($this->info['zones']['zw-footer']) && !empty($this->info['zones']['zw-footer']) ? $this->info['zones']['zw-footer'] : array();
*/	
	//$this->info['zones']['zw-main'] = isset($this->info['zones']['zw-main']) && !empty($this->info['zones']['zw-main']) ? $this->info['zones']['zw-main'] : null;
	
	//$this->config = (isset($config) && !empty($config)) ? $config : $this->config;
	//$this->info = (isset($info) && !empty($info)) ? $info : $this->info;

		//echo '<pre>'.print_r($this, 1).'</pre>';

		$key = 0;
		$content = null;

		//$zones = $this->info['zones'];
		//echo '<pre>'.print_r($name, 1).'</pre>';

		if($name == null) $zones = $this->info['zones']['zw-main'];
		else $zones = $this->info['zones'][$name];
		
		//echo '<pre>INFOS: '.$name.' '.print_r($zones, 1).'</pre>'; //exit;

		if(is_array($zones)):
		
		foreach($zones as $key => $zone) {

				//$adddiv = explose()
				$tmp = "\n\t\t".'<!-- '.$key.' -->'."\n";
				$tmp.= "\t\t".'<div id="'.$key.'">'."\n";
				if(is_array($zone)):
				foreach($zone as $clef => $div) {
					//echo $key.$clef.''.' - '.$div['tpl'].''.'<br />';
					$tmp.= "\n\t\t".'<!-- '.$div['div'].' -->'."\n";
					$tmp.= "\t\t".'<div id="'.$div['div'].'">'."\n";

					//$tmp.= '<pre>'.print_r($div, 1).'</pre>';
					//$tmp.= $this->zwViews()->getView($div['div'], $div['tpl'], $div['module'], $div['function'], $div['arguments']);
					$tmp.= zw3bViews::getView($div['div'], $div['tpl'], $div['module'], $div['function'], $div['arguments']);
					//$tmp.= $this->zwViews()->getViewTmp($div);

					$tmp.= "\n\t\t".'</div>'."\n";
					$tmp.= "\t\t".'<!-- /'.$div['div'].' -->'."\n";

					if($clef == count($zone)-1)
					$tmp.= "\n\t\t".'<hr class="clear-bloc" />'."\n";

				}
				endif;
				$tmp.= "\n\t\t".'</div>'."\n";
				$tmp.= "\n\t\t".'<hr class="clear-line" />'."\n";
				$tmp.= "\t\t".'<!-- /'.$key.' -->'."\n";

				$content = $content.$tmp;
		}
		endif;
		return $content;
	}

	function assign($name, $value) {
		//echo '<i>zw3b Assign le tableau <strong>"$fields['.$name.']"</strong> avec la valeur : '.print_r($value,1).' <strong>|||</strong> <br/></i>';
		$this->fields[$name] = $value;
	}

}

?>